"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Suffixes internal event part
 * to the given event
 *
 * @param ev Event
 */
const internalEvent = (ev) => `__int_ev__/${ev}`;
/**
 * @hidden
 *
 * Holds all the topics for internal-events
 * such as on init,subscribe,unsubscribe&error
 */
exports.InternalEvents = {
    ON_INIT: internalEvent('INIT'),
    ON_SUBSCRIBE: internalEvent('ON_SUBSCRIBE'),
    ON_UNSUBSCRIBE: internalEvent('ON_UNSUBSCRIBE'),
    ON_ERROR: internalEvent('ON_ERROR'),
};
/**
 * @hidden
 *
 * This reverse mapping of topic to internal event
 * is used as a predicate to check if the given topic is
 * an internal event or not
 */
exports.InternalEventsRev = {
    [internalEvent('INIT')]: 'ON_INIT',
    [internalEvent('ON_SUBSCRIBE')]: 'ON_SUBSCRIBE',
    [internalEvent('ON_UNSUBSCRIBE')]: 'ON_UNSUBSCRIBE',
    [internalEvent('ON_ERROR')]: 'ON_ERROR',
};
//# sourceMappingURL=internalEvents.js.map