"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function mergeOptions(givenOpts = {}, defaultOpts = {}) {
    return [...new Set([
            ...Object.keys(givenOpts),
            ...Object.keys(defaultOpts),
        ])].reduce((result, key) => {
        if (typeof givenOpts[key] === 'object') {
            result[key] = mergeOptions(givenOpts[key], defaultOpts[key]);
        }
        else {
            result[key] = givenOpts[key] !== undefined
                ? givenOpts[key]
                : defaultOpts[key];
        }
        return result;
    }, {});
}
exports.default = mergeOptions;
//# sourceMappingURL=mergeOptions.js.map