"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const pattern_1 = require("./pattern");
/**
 * Creates a middleware which will be run
 * only when the pubEvent matches the given
 * pattern
 *
 * @param pattern Subscription event
 * @param middleware Middleware subscribed on the pattern
 */
function patternHandler(pattern, middleware) {
    return (ctx) => {
        if (pattern_1.doesPatternMatch(ctx.pubEvent, pattern)) {
            return middleware(ctx);
        }
        return ctx.data;
    };
}
exports.default = patternHandler;
//# sourceMappingURL=patternHandler.js.map